<html>
<head>
    <!-- <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js"></script> -->
	<script type="text/javascript" src="Scripts/jquery.min.js" ></script>
    <script type="text/javascript">
        $(function() {
			var lstab = "SELECT tablename FROM pg_catalog.pg_tables WHERE schemaname != 'pg_catalog' AND schemaname != 'information_schema'";
            getSQL(lstab,"json",function(data) {
                $.each(data.items,function(i,it) {
                    if(it.tablename != 'method') {
                        $('<option>').attr('value',it.tablename).append(
                            it.tablename
                        ).appendTo(
                            $('#tables')
                        );
                    }
                });
            });
            $('#tables').change(function() {
                var thisTable = $(this).val();
                if(thisTable != "-1") {
                    var sql = 'SELECT ';
                    var fields = new Array();
                    getSQL("SELECT column_name FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name ='"+thisTable+"'","json",function(data) {
                        $.each(data.items,function(i,it) {
                            fields.push(it.column_name);
                        });
                        sql += fields+" FROM "+thisTable;
                        $('#query').val(sql);
                    });
                }
            });
			
            $('#query').keyup(function(event) {
                var url = $('#query').val();
                var re  = /\{(.[^\}]+)\}/g;
                var match;
                var html = $('<fieldset>').append('Parametros:').attr('id','parametros');
                while (match = re.exec(url)) {
                    $('<div>').append(
                        match[1]+" "
                    ).append(
                        $('<input>').attr('type','text').attr('id','{'+match[1]+'}')
                    ).appendTo(html);
                }
                $('#params').html(html);
            });
            $('#qTest').click(function() {
                var sql = $('#query').val();
                $.each($('#parametros :input'),function(i,item) {
                    sql = sql.replace($(this).attr('id'),$(this).val());
                });
				
				//alert(sql);
                getSQL(sql,"html",function(data){
                    $('#out').html(data);
                });
            });
			
            $('#qAdd').click(function() {
                $.post('addApi.php',{
                                    name: $('#name').val(),
                                    tabla: $('#tables').val(),
                                    query: $('#query').val()
                },function(data) {
					alert("ok");
                    $('#boxB').html('OK').hide('slow');
                });
            });
            $('#name').blur(function() {
                getSQL("SELECT * FROM Method WHERE name='"+$(this).val()+"' and tabla='"+$('#tables').val()+"'","json",function(data) {
                    if(data.items.length > 0) {
                        alert('Method ya existe');
                        $('#name').val('');
                    }
                });
            });
        });
        function getSQL(sql,type,callback) {
            $.ajax({
                type: "GET",
                url: 'queryTest.php',
                data: 'query='+sql,
                dataType: type,
                success: callback
            });
        }
    </script>
</head>
<body>
<form>
    <fieldset>
        WebService Name:
        <select id="tables">
            <option value="-1">Tablas:</option>
        </select>.<input type="text" id="name" />
    </fieldset>
    <fieldset>
        WebService Query:
        <textArea id="query" style="width: 100%; height: 50px;"></textArea>
    </fieldset>
    <div id="params"></div>
    <input id="qTest" type="button" value="Test Query" />
    <input id="qAdd" type="button" value="Agrega WebService" />
</form>
<div id="box">
    <textArea id="out" style="width: 100%; height: 500px;"></textArea>
</div>
<div id="boxB"></div>
</body>
</html>